#include <vector>
#include <string>
using namespace std;

//returns number of lines
int wrapprint( const string& str, int x, int y, int width=19 )
{
	
    if (width==0)
        return 0;
	
	int linecount=0;
	
    string s=str+" ";
    int cury=y;
    unsigned int startp=0;
    while (startp<s.size())
    {
        int endp=startp+1;
        int lastspace=-1;
		
        while (endp-startp<=width)
        {
			
            if (endp==s.size())
            {
                lastspace=endp;
                break;
            }
            if (s[endp]=='\n')
            {
                lastspace=endp;
                break;
            }
            else if (s[endp]==' ')
            {
                lastspace=endp;
            }
            endp++;
        }
		
        if (lastspace>=0)//wrap a word around
        {
            //if two consecutive newlines
            if (s.substr(startp,lastspace-startp)=="\n")
            {
                startp=lastspace+1;
            }
            else
            {
				textout_ex(buffer, font, s.substr(startp,lastspace-startp).c_str(), x, cury, makecol(100,100,100), makecol(0,0,0));
                startp=lastspace+1;
            }
			linecount++;			
        }
        else //word bigger than line, just thunk
        {
			textout_ex(buffer, font, s.substr(startp,endp-startp).c_str(), x, cury, makecol(100,100,100), makecol(0,0,0));
            startp+=width;
			linecount++;
        }
		
        cury+=10;
		
    }
	
	return linecount;
}